package comm

///内置错误码 0-1000  请外部应用服务不要占用
const (
	ErrorCode_Success                 int32 = 0  //成功
	ErrorCode_NoFindService           int32 = 10 //没有找到远程服务器
	ErrorCode_RpcFuncExecutionError   int32 = 11 //Rpc方法执行错误
	ErrorCode_CacheReadError          int32 = 12 //缓存读取失败
	ErrorCode_SqlExecutionError       int32 = 13 //数据库执行错误
	ErrorCode_ReqParameterError       int32 = 14 //请求参数错误
	ErrorCode_SignError               int32 = 15 //签名错误
	ErrorCode_InsufficientPermissions int32 = 16 //权限不足
	ErrorCode_NoLogin                 int32 = 17 //未登录
	ErrorCode_UserSessionNobeing      int32 = 18 //用户不存在
)

var ErrorCodeMsg = map[int32]string{
	ErrorCode_Success:                 "成功",
	ErrorCode_NoFindService:           "没有找到远程服务器",
	ErrorCode_RpcFuncExecutionError:   "Rpc方法执行错误",
	ErrorCode_CacheReadError:          "缓存读取失败",
	ErrorCode_SqlExecutionError:       "数据库执行错误",
	ErrorCode_ReqParameterError:       "请求参数错误",
	ErrorCode_SignError:               "签名错误",
	ErrorCode_InsufficientPermissions: "权限不足",
	ErrorCode_NoLogin:                 "未登录",
	ErrorCode_UserSessionNobeing:      "用户不存在",
}

func GetErrorCodeMsg(code int32) string {
	if v, ok := ErrorCodeMsg[code]; ok {
		return v
	} else {
		return "未描述"
	}
}
