package main

import (
	"flag"
	"go_dreamfactory/modules/gateway"
	"go_dreamfactory/services"

	"github.com/liwei1dao/lego"
	"github.com/liwei1dao/lego/base/rpcx"
	"github.com/liwei1dao/lego/core"
)

var (
	conf = flag.String("conf", "./conf/gateway_1.yaml", "获取需要启动的服务配置文件") //启动服务的Id
)

func main() {
	flag.Parse()
	s := NewService(
		rpcx.SetConfPath(*conf),
		rpcx.SetVersion("1.0.0.0"),
	)
	s.OnInstallComp( //装备组件
	)
	lego.Run(s, //运行模块
		gateway.NewModule(),
	)

}

func NewService(ops ...rpcx.Option) core.IService {
	s := new(Service)
	s.Configure(ops...)
	return s
}

type Service struct {
	services.ServiceBase
}

func (this *Service) InitSys() {
	this.ServiceBase.InitSys()
}
