package db

import (
	"github.com/liwei1dao/lego/sys/mgo"
)

func newSys(options Options) (sys *DB, err error) {
	sys = &DB{options: options}
	err = sys.init()
	return
}

type DB struct {
	options Options
	mgo     mgo.ISys
}

func (this *DB) init() (err error) {
	if this.mgo, err = mgo.NewSys(
		mgo.SetMongodbUrl(this.options.MongodbUrl),
		mgo.SetMongodbDatabase(this.options.MongodbDatabase),
	); err != nil {
		return
	}
	err = this.checkUserIdInit()
	return
}
